Index: cpukit/score/Makefile.am
===================================================================
--- cpukit/score/Makefile.am	(revision 1512761142b4a4ba6c9c8920f763186ae06dd8ab)
+++ cpukit/score/Makefile.am	(revision 43e1573c1f02194a4fa754dfbff51862130742a5)
@@ -203,4 +203,5 @@
     src/objectnamespaceremove.c \
     src/objectactivecount.c
+libscore_a_SOURCES += src/objectacquire.c
 
 ## SCHEDULER_C_FILES
Index: cpukit/score/include/rtems/score/object.h
===================================================================
--- cpukit/score/include/rtems/score/object.h	(revision 1512761142b4a4ba6c9c8920f763186ae06dd8ab)
+++ cpukit/score/include/rtems/score/object.h	(revision 43e1573c1f02194a4fa754dfbff51862130742a5)
@@ -24,4 +24,5 @@
 #include <rtems/score/cpu.h>
 #include <rtems/score/chain.h>
+#include <rtems/score/isrlock.h>
 
 #ifdef __cplusplus
@@ -237,4 +238,6 @@
   /** This is the object's name. */
   Objects_Name   name;
+  /** This is the object's ISR lock. */
+  ISR_LOCK_MEMBER( Lock )
 } Objects_Control;
 
Index: cpukit/score/include/rtems/score/objectimpl.h
===================================================================
--- cpukit/score/include/rtems/score/objectimpl.h	(revision 1512761142b4a4ba6c9c8920f763186ae06dd8ab)
+++ cpukit/score/include/rtems/score/objectimpl.h	(revision 43e1573c1f02194a4fa754dfbff51862130742a5)
@@ -592,4 +592,81 @@
 
 /**
+ * @brief Acquires an object by its identifier.
+ *
+ * This function is similar to _Objects_Get_isr_disable().  It acquires the
+ * object specific ISR lock for local objects.  Thread dispatching is not
+ * disabled for local objects.  For remote objects thread dispatching is
+ * disabled.
+ *
+ * @param[in] information The object information.
+ * @param[in] id The object identifier.
+ * @param[in] location The location of the object.
+ * @param[in] lock_context The lock context for local objects.
+ *
+ * @retval object The object corresponding to the identifier.
+ * @retval NULL No object exists in this domain for this identifer.
+ *
+ * @see _Objects_Release(), _Objects_Release_and_ISR_enable(), and
+ * _Objects_Release_and_thread_dispatch_disable().
+ */
+Objects_Control *_Objects_Acquire(
+  const Objects_Information *information,
+  Objects_Id                 id,
+  Objects_Locations         *location,
+  ISR_lock_Context          *lock_context
+);
+
+/**
+ * @brief Releases a local object.
+ *
+ * @param[in] the_object The local object acquired by _Objects_Acquire().
+ * @param[in] lock_context The lock context initialized by _Objects_Acquire().
+ */
+RTEMS_INLINE_ROUTINE void _Objects_Release(
+  Objects_Control  *the_object,
+  ISR_lock_Context *lock_context
+)
+{
+  _ISR_lock_Release( &the_object->Lock, lock_context );
+}
+
+/**
+ * @brief Releases a local object and restores the interrupt level.
+ *
+ * @param[in] the_object The local object acquired by _Objects_Acquire().
+ * @param[in] lock_context The lock context initialized by _Objects_Acquire().
+ */
+RTEMS_INLINE_ROUTINE void _Objects_Release_and_ISR_enable(
+  Objects_Control  *the_object,
+  ISR_lock_Context *lock_context
+)
+{
+  _ISR_lock_Release_and_ISR_enable( &the_object->Lock, lock_context );
+}
+
+/**
+ * @brief Releases a local object, disables thread dispatching and restores the
+ * interrupt level.
+ *
+ * @param[in] the_object The local object acquired by _Objects_Acquire().
+ * @param[in] lock_context The lock context initialized by _Objects_Acquire().
+ *
+ * @return The current processor.
+ */
+RTEMS_INLINE_ROUTINE Per_CPU_Control *
+_Objects_Release_and_thread_dispatch_disable(
+  Objects_Control  *the_object,
+  ISR_lock_Context *lock_context
+)
+{
+  Per_CPU_Control *cpu_self = _Per_CPU_Get();
+
+  _Thread_Dispatch_disable_critical( cpu_self );
+  _Objects_Release_and_ISR_enable( the_object, lock_context );
+
+  return cpu_self;
+}
+
+/**
  *  Like @ref _Objects_Get, but is used to find "next" open object.
  *
@@ -904,4 +981,5 @@
 
   the_object->name = name;
+  _ISR_lock_Initialize( &the_object->Lock, "Object" );
 
   _Objects_Set_local_object(
@@ -928,4 +1006,5 @@
   /* ASSERT: information->is_string == false */
   the_object->name.name_u32 = name;
+  _ISR_lock_Initialize( &the_object->Lock, "Object" );
 
   _Objects_Set_local_object(
@@ -954,4 +1033,5 @@
     the_object->name.name_p = name;
   #endif
+  _ISR_lock_Initialize( &the_object->Lock, "Object" );
 
   _Objects_Set_local_object(
Index: cpukit/score/src/objectacquire.c
===================================================================
--- cpukit/score/src/objectacquire.c	(revision 43e1573c1f02194a4fa754dfbff51862130742a5)
+++ cpukit/score/src/objectacquire.c	(revision 43e1573c1f02194a4fa754dfbff51862130742a5)
@@ -0,0 +1,80 @@
+/**
+ * @file
+ *
+ * @brief Object Acquire
+ *
+ * @ingroup ScoreObject
+ */
+
+/*
+ * Copyright (c) 2015 embedded brains GmbH.  All rights reserved.
+ *
+ *  embedded brains GmbH
+ *  Dornierstr. 4
+ *  82178 Puchheim
+ *  Germany
+ *  <rtems@embedded-brains.de>
+ *
+ * The license and distribution terms for this file may be
+ * found in the file LICENSE in this distribution or at
+ * http://www.rtems.org/license/LICENSE.
+ */
+
+#if HAVE_CONFIG_H
+  #include "config.h"
+#endif
+
+#include <rtems/score/objectimpl.h>
+
+Objects_Control *_Objects_Acquire(
+  const Objects_Information *information,
+  Objects_Id                 id,
+  Objects_Locations         *location,
+  ISR_lock_Context          *lock_context
+)
+{
+  Objects_Control *the_object;
+  uint32_t         index;
+
+  index = id - information->minimum_id + 1;
+
+  if ( information->maximum >= index ) {
+    /*
+     * On uni-processor configurations we disable interrupts before we use the
+     * local table.  This prevents use of freed memory in case the object
+     * information is extended in between.  On SMP configurations bad things
+     * can happen, see https://devel.rtems.org/ticket/2280.
+     */
+#if !defined(RTEMS_SMP)
+    ISR_Level level;
+
+    _ISR_Disable( level );
+#endif
+    if ( ( the_object = information->local_table[ index ] ) != NULL ) {
+      *location = OBJECTS_LOCAL;
+#if defined(RTEMS_SMP)
+      _ISR_lock_ISR_disable_and_acquire( &the_object->Lock, lock_context );
+#else
+      lock_context->isr_level = level;
+#endif
+
+      return the_object;
+    }
+#if !defined(RTEMS_SMP)
+    _ISR_Enable( level );
+#endif
+    *location = OBJECTS_ERROR;
+
+    return NULL;
+  }
+
+  *location = OBJECTS_ERROR;
+
+#if defined(RTEMS_MULTIPROCESSING)
+  _Objects_MP_Is_remote( information, id, location, &the_object );
+
+  return the_object;
+#else
+  return NULL;
+#endif
+}
Index: cpukit/score/src/objectclose.c
===================================================================
--- cpukit/score/src/objectclose.c	(revision 1512761142b4a4ba6c9c8920f763186ae06dd8ab)
+++ cpukit/score/src/objectclose.c	(revision 43e1573c1f02194a4fa754dfbff51862130742a5)
@@ -29,3 +29,5 @@
 
   _Objects_Namespace_remove( information, the_object );
+
+  _ISR_lock_Destroy( &the_object->Lock );
 }
